#ifndef __RT_ARITHM__
#define __RT_ARITHM__

/* asm/arithm.h
*
*  1995 Michael Barabanov
*/


#ifndef rtl_div_t
typedef struct {
	int quot;	/* Quotient.  */
	int rem;	/* Remainder.  */
} rtl_div_t;
#endif



/*  a * mult / div  */

static inline rtl_div_t imuldivmod(int a, int mult, int div)
{
	register rtl_div_t res;
	__asm__("imull %1 ; idivl %3"
	:	"=a"(res.quot),
		"=d"(res.rem)
	:	"1"(mult),
		"r"(div),
		"0"(a)
      	:	"dx");
	return res;
}

/* a * mult / div */

static inline int imuldiv(int a, int mult, int div)
{
	__asm__("imull %1 ; idivl %2"
		:"=a" (a)
		:"d" (mult),
		 "r" (div),
		 "0" (a)
		:"dx");
	return a;
}


#endif /* defined(__RT_ARITHM__) */
